#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <errno.h>
#include <fcntl.h>
#include <errno.h>

#define NUM_BYTES_TO_READ 500

int main(int argc, char *argv[])
{

	if( argc != 4 ){

        printf("USAGE: server file serverIpAddress port_number\n");

        return EXIT_FAILURE;

    }

   int len, mysocket;
   struct sockaddr_in dest;

   mysocket = socket(AF_INET, SOCK_STREAM, 0);

   memset(&dest, 0, sizeof(dest));                /* zero the struct */
   dest.sin_family = AF_INET;
   dest.sin_addr.s_addr = inet_addr( argv[ 2 ]); /* set destination IP number - localhost, 127.0.0.1*/
   dest.sin_port = htons( atoi( argv[ 3 ] ) );                /* set destination port number */

   int connectResult = connect(mysocket, (struct sockaddr *)&dest, sizeof(struct sockaddr_in));

   if( connectResult == - 1 ){

   		printf("CLIENT ERROR: %s\n", strerror(errno));

   		return EXIT_FAILURE;
   }

  char* file = argv[ 1 ];

  int fd = open( file, O_CREAT | O_RDWR, S_IRWXU );

  int numBytesToRead = 0;
  int numBytesRead = 0;
  int numBytesWritten = 0;
  int counter = 0;

  char* buffer = (char*) calloc( NUM_BYTES_TO_READ + 1, sizeof( char ) );

  while( 1 ){

      numBytesRead = recv( mysocket, &numBytesToRead, sizeof( int ), 0 );

      if( numBytesRead == 0 || numBytesToRead == -1 ){
          printf("End of transmission!\n" );
          break;

      }

      numBytesRead = recv( mysocket, buffer, numBytesToRead * sizeof( char ), 0 );

      // ATTENTION: recv does not guarantee that all the bytes requested will be read
      // the recv operation may need to be repeated to receive all the bytes originally
      // requested
      while( numBytesRead < numBytesToRead ){

          numBytesRead += recv( mysocket, buffer, ( numBytesToRead - numBytesRead ) * sizeof( char ), 0 );

      }

      numBytesWritten = write( fd, buffer, numBytesToRead * sizeof( char ) );
      printf("numBytesToRead:%d numBytesRead:%d numBytesWritten:%d\n", numBytesToRead, numBytesRead, numBytesWritten );

	  if( numBytesRead == -1 ){
		  perror("error");
          break;

      }
  }

   close( mysocket );

   return EXIT_SUCCESS;
}
