#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <errno.h>
#include <fcntl.h>
#include <netinet/in.h>


#define NUM_BYTES_TO_READ 500

int main(int argc, char *argv[])
{

    if( argc != 3 ){

        printf("USAGE: server fileToShare port_number\n");

        return EXIT_FAILURE;

    }

    srand( time( NULL ));

    struct sockaddr_in dest; /* socket info about the machine connecting to us */
    struct sockaddr_in serv; /* socket info about our server */
    int mysocket;            /* socket used to listen for incoming connections */
    socklen_t socksize = sizeof(struct sockaddr_in);

    memset(&serv, 0, sizeof(serv));           /* zero the struct before filling the fields */
    serv.sin_family = AF_INET;                /* set the type of connection to TCP/IP */
    serv.sin_addr.s_addr = htonl(INADDR_ANY); /* set our address to any interface */
    serv.sin_port = htons( atoi( argv[ 2 ] ) );           /* set the server port number */

    mysocket = socket(AF_INET, SOCK_STREAM, 0);

    /* bind serv information to mysocket */
    bind(mysocket, (struct sockaddr *)&serv, sizeof(struct sockaddr));

    /* start listening, allowing a queue of up to 1 pending connection */
    listen(mysocket, 1);

    printf("Server is waiting for connections on port:%s\n", argv[ 2 ] );

    int consocket = accept(mysocket, (struct sockaddr *)&dest, &socksize);

    printf("Incoming connection from %s - sending welcome\n", inet_ntoa(dest.sin_addr));

    char* file = argv[ 1 ];

    int fd = open( file, O_RDONLY );

    int numBytesRead = 0;
    int numBytesSentInt = 0;
    int numBytesSentBuf = 0;

    char* buffer = (char*) calloc( NUM_BYTES_TO_READ, sizeof( char ) );

    while( 1 ){

        numBytesRead = read( fd, buffer, NUM_BYTES_TO_READ * sizeof( char ) );
        numBytesSentInt = send( consocket, &numBytesRead, sizeof( int ), 0 );
        numBytesSentBuf = send( consocket, buffer, numBytesRead * sizeof( char ), 0 );
        printf("numBytesRead:%d numBytesSentInt:%d numBytesSentBuf:%d\n", numBytesRead, numBytesSentInt, numBytesSentBuf );

        if( numBytesRead < ( NUM_BYTES_TO_READ * sizeof( char ) ) ){

            break;
        }

    }
    numBytesRead = -1;
    send( consocket, &numBytesRead, sizeof( int ), 0 );

    close( mysocket );
    return EXIT_SUCCESS;
}
