#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <errno.h>

#define MAXRCVLEN 500
#define NUMBER_OF_COMMUNICATIONS 5

int main(int argc, char *argv[])
{

	if( argc != 2 ){

		printf("USAGE: server port_number\n");

		return EXIT_FAILURE;

	}

	int len 			= 0;
	int mysocket 		= 0;
	int connectResult 	= 0;
	int randomNumber 	= 0;

	char buffer[MAXRCVLEN + 1]; /* +1 so we can add null terminator */

	struct sockaddr_in dest;

	for( int communicationCounter = 0; communicationCounter < NUMBER_OF_COMMUNICATIONS; communicationCounter++ ){

		//bzero( buffer, MAXRCVLEN + 1 );

		mysocket = socket(AF_INET, SOCK_STREAM, 0);
		memset(&dest, 0, sizeof(dest));                			   /* zero the struct */
		dest.sin_family = AF_INET;
		dest.sin_addr.s_addr = htonl(INADDR_LOOPBACK);             /* set destination IP number - localhost, 127.0.0.1*/
		dest.sin_port = htons( atoi( argv[ 1 ] ) );                /* set destination port number */

		connectResult = connect(mysocket, (struct sockaddr *)&dest, sizeof(struct sockaddr_in));

		if( connectResult == - 1 ){

			printf("CLIENT ERROR: %s\n", strerror(errno));

			return EXIT_FAILURE;
		}

		len = recv( mysocket, &randomNumber, sizeof( int ), 0 );
		printf("Client received number:%d\n", randomNumber );

		randomNumber = rand();
		printf("Client sent number:%d\n\n", randomNumber );
		len = send(mysocket, &randomNumber, sizeof( int ), 0);

		close(mysocket);

	}

	return EXIT_SUCCESS;
}
