#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <errno.h>
#include <pthread.h>

void *print_message_function( void *ptr );

typedef struct ThreadArgument_t{

	int numberReceived;
	int socket;

}ThreadArgument;

void* print_message_function( void *ptr )
{
	ThreadArgument* arg = (ThreadArgument*) ptr;

	printf("\t\t[THREAD]::Server received number:%d\n\n", arg->numberReceived );

	// We can only close the communication socket after the thread finishes:
	close( arg->socket );

	return (void*) 0;
}

int main(int argc, char *argv[])
{

	if( argc != 2 ){

		printf("USAGE: server port_number\n");

		return EXIT_FAILURE;

	}

	srand( time( NULL ));

	struct sockaddr_in dest; /* socket info about the machine connecting to us */
	struct sockaddr_in serv; /* socket info about our server */
	int mysocket;            /* socket used to listen for incoming connections */
	socklen_t socksize = sizeof(struct sockaddr_in);

	memset(&serv, 0, sizeof(serv));           /* zero the struct before filling the fields */
	serv.sin_family = AF_INET;                /* set the type of connection to TCP/IP */
	serv.sin_addr.s_addr = htonl(INADDR_ANY); /* set our address to any interface */
	serv.sin_port = htons( atoi( argv[ 1 ] ) );           /* set the server port number */

	int iret1 = 0;
	pthread_t thread1;

	mysocket = socket(AF_INET, SOCK_STREAM, 0);

	/* bind serv information to mysocket */
	bind(mysocket, (struct sockaddr *)&serv, sizeof(struct sockaddr));

	/* start listening, allowing a queue of up to 1 pending connection */
	listen(mysocket, 1);

	printf("Server is waiting for connections on port:%s\n", argv[ 1 ] );

	int consocket = accept(mysocket, (struct sockaddr *)&dest, &socksize);

	while( 1 ){

		while(consocket)
		{
			printf("\tIncoming connection from %s - sending welcome\n", inet_ntoa(dest.sin_addr));

			int randomNumber = rand();

			printf("\t\tServer sending number:%d\n", randomNumber );
			send(consocket, &randomNumber, sizeof( int ), 0);


			recv(consocket, &randomNumber, sizeof( int ), 0);


			printf("\t\tServer received number:%d\n", randomNumber );
			//close(consocket);

			ThreadArgument arg;

			arg.numberReceived = randomNumber;
			arg.socket = consocket;
			iret1 = pthread_create( &thread1, NULL, print_message_function, (void*) &arg );
			     if(iret1)
			     {
			         fprintf(stderr,"Error - pthread_create() return code: %d\n",iret1);
			         exit( EXIT_FAILURE );
			     }
			consocket = accept(mysocket, (struct sockaddr *)&dest, &socksize);
		}

		close(mysocket);
	}

	return EXIT_SUCCESS;
}
